//
//  util.h
//  
//
//  Created by Roni Mittelman on 8/15/13.
//
//

#ifndef ____util__
#define ____util__

#include <fstream>
#include <iostream>
#include <valarray>
#include <vector>
#include <string.h>
#endif /* defined(____util__) */

namespace util{
    void save_matrix2file(char *filename, std::valarray<float> dataV, int num_of_rows, int num_of_cols);
    void read_data(char *filename, std::vector<std::valarray<float> > *data, std::valarray<int> *Tvct, int *NVisible);
    void select_data_indices(std::vector<std::valarray<float> > *data, std::valarray<int> *Tvct, std::valarray<int> indices);
    void create_obs_transform_matrix(int NBlocksSide,int BlockSideLen, std::valarray<float> *T);
    void read_obs_transform_matrix(char *filename, std::valarray<float> *T, std::valarray<int> *dim);
    void permute_data(std::vector<std::valarray<float> > *data, std::valarray<int> Tvct, int NVisible, std::valarray<float> T);
    void read_parms(char *filename, char *parameters_filename, int *type, int *n_CD, int *num_of_nodes, std::valarray<int> *NVisible, std::valarray<int> *NHidden, int *num_of_iterations, float *learning_rate, float *momentum, float *l1_Theta_reg, int *flag_learn_mask, int *flag_causal, int *flag_share_lambda_parm, float *alpha_parm, float *lambda_parm_init, float *delta_parm, float *kappa, char** argv);
}